<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <!-- font -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Lato"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="css/stylemin.css" />
    <link rel="stylesheet" href="css/color.css" />

    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"
      integrity="sha512-3gJwYpMe3QewGELv8k/BX9vcqhryRdzRMxVfq6ngyWXwo03GFEzjsUm8Q7RZcHPHksttq7/GFoxjCVUjkjvPdw=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer"
    ></script>

    <title>Pizza 365 v0.5</title>
  </head>

  <body onload="onPageLoading()">
    <!-- Menu -->
    <div class="container-fluid">
      <div class="row">
        <div class="col-sm-12">
          <nav class="navbar fixed-top navbar-expand-lg navbar-light bg-light">
            <button
              class="navbar-toggler"
              type="button"
              data-toggle="collapse"
              data-target="#navbarNav"
              aria-controls="navbarNav"
              aria-expanded="false"
              aria-label="Toggle navigation"
            >
              <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarNav">
              <ul class="navbar-nav nav-fill w-100">
                <li class="nav-item active">
                  <a class="nav-link" href="#">HOME</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="#combo">SIZE COMBOS</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="#type">PIZZA TYPES</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="#contact">FORM CONTACT</a>
                </li>
              </ul>
            </div>
          </nav>
        </div>
      </div>
    </div>

    <!-- Content -->
    <div class="container" style="padding: 70px 0px 50px 0px;">
      <div class="row">
        <div class="col-sm-12">
          <div class="row">
            <!-- Title row home -->
            <div class="col-sm-12">
              <h1><b class="text-main">Pizza 365</b></h1>
              <p style="font-style: italic;" class="text-second">
                Truly italian!
              </p>
            </div>

            <!-- Slide row home -->
            <div class="col-sm-12">
              <div
                id="carouselExampleIndicators"
                class="carousel slide"
                data-ride="carousel"
              >
                <ol class="carousel-indicators">
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="0"
                    class="active"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="1"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="2"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="3"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="4"
                  ></li>

                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="5"
                  ></li>
                  <li
                    data-target="#carouselExampleIndicators"
                    data-slide-to="6"
                  ></li>
                </ol>
                <div class="carousel-inner">
                  <div class="carousel-item active">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_1.jpg"
                      alt="First slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_2.jpg"
                      alt="Second slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_3.jpg"
                      alt="Third slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_4.jpg"
                      alt="Fourth slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_5.jpg"
                      alt="Fifth slide"
                    />
                  </div>

                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_6.jpg"
                      alt="Sixth slide"
                    />
                  </div>
                  <div class="carousel-item">
                    <img
                      class="d-block w-100"
                      src="images/anh_mon_7.jpg"
                      alt="Seventh slide"
                    />
                  </div>
                </div>
                <a
                  class="carousel-control-prev"
                  href="#carouselExampleIndicators"
                  role="button"
                  data-slide="prev"
                >
                  <span
                    class="carousel-control-prev-icon"
                    aria-hidden="true"
                  ></span>
                  <span class="sr-only">Previous</span>
                </a>
                <a
                  class="carousel-control-next"
                  href="#carouselExampleIndicators"
                  role="button"
                  data-slide="next"
                >
                  <span
                    class="carousel-control-next-icon"
                    aria-hidden="true"
                  ></span>
                  <span class="sr-only">Next</span>
                </a>
              </div>
            </div>

            <!-- Title ưu điểm của Quán -->
            <div class="col-sm-12 text-center p-4 mt-4">
              <h2><b class="p-2 border-bottom">Tại sao lại Pizza 365</b></h2>
            </div>

            <!-- Content ưu điểm của Quán -->
            <div class="col-sm-12">
              <div class="row">
                <div class="col-sm-3 p-3 bg-brand-01 text-white border">
                  <h3 class="p-2">Không ngừng cải tiến</h3>
                  <p class="p-2">
                    Cải tiến sản phẩm, chất lượng và trải nghiệm khách hàng luôn
                    là yếu tố tiên quyết trong chiến lược kinh doanh của chúng
                    tôi nhằm thúc đẩy tăng trưởng và trở thành thương hiệu pizza
                    hàng đầu.
                  </p>
                </div>
                <div class="col-sm-3 p-3 bg-brand-02 text-white border">
                  <h3 class="p-2">Trải nghiệm dễ dàng</h3>
                  <p class="p-2">
                    Chúng tôi đơn giản hướng đến việc trở thành thương hiệu của
                    mọi nhà, mọi lúc, mọi nơi.
                  </p>
                </div>
                <div class="col-sm-3 p-3 bg-brand-03 text-white border">
                  <h3 class="p-2">Hướng đến sự vượt trội</h3>
                  <p class="p-2">
                    "Vượt trội" không chỉ là một khái niệm lớn. Thay vào đó, giá
                    trị này là cốt lõi trong mỗi con người của chúng tôi, trong
                    mỗi công việc mà họ làm.
                  </p>
                </div>
                <div class="col-sm-3 p-3 bg-brand-04 text-white border">
                  <h3 class="p-2">Thể hiện đam mê</h3>
                  <p class="p-2">
                    Chúng tôi sẵn lòng hỗ trợ vô điều kiện và linh động điều
                    chỉnh tùy theo thử thách để tìm ra giải pháp.
                  </p>
                </div>
              </div>
            </div>
          </div>

          <div id="combo" class="row">
            <!-- Title Size Combos -->
            <div class="col-sm-12 text-center p-4 mt-4">
              <h2><b class="p-1 border-bottom">Menu combo Pizza 365</b></h2>
              <p><span class="p-2">Hãy chọn combo phù hợp với bạn</span></p>
            </div>
            <!-- Content các Size Combos -->
            <div class="col-sm-12">
              <div class="row" id="div-row-size-combo">
                <!-- <div class="col-sm-4">
                  <div class="card">
                    <div
                      class="card-header bg-main-brand text-white text-center"
                    >
                      <h3>S ( Small size)</h3>
                    </div>
                    <div class="card-body text-center">
                      <ul class="list-group list-group-flush">
                        <li class="list-group-item">
                          Đường kính <b> 20 cm</b>
                        </li>
                        <li class="list-group-item">Sườn nướng <b>2</b></li>
                        <li class="list-group-item">Salad <b>200 gr</b></li>
                        <li class="list-group-item">Nước ngọt <b>2</b></li>
                        <li class="list-group-item">
                          <h1>VND <b>150,000</b></h1>
                        </li>
                      </ul>
                    </div>
                    <div class="card-footer text-center">
                      <button
                        class="btn-green"
                        id="btn-size-small"
                        data-is-selected="N"
                        onclick="onBtnChonSizeSClick()"
                      >
                        Chọn
                      </button>
                    </div>
                  </div>
                </div>
                <div class="col-sm-4">
                  <div class="card">
                    <div
                      class="card-header bg-main-brand text-white text-center"
                    >
                      <h3>M (Medium size)</h3>
                    </div>
                    <div class="card-body text-center">
                      <ul class="list-group list-group-flush">
                        <li class="list-group-item">
                          Đường kính <b> 25 cm</b>
                        </li>
                        <li class="list-group-item">Sườn nướng <b>4</b></li>
                        <li class="list-group-item">Salad <b> 300 gr</b></li>
                        <li class="list-group-item">Nước ngọt <b>3</b></li>
                        <li class="list-group-item">
                          <h1>VND <b>200,000</b></h1>
                        </li>
                      </ul>
                    </div>
                    <div class="card-footer text-center">
                      <button
                        class="btn-green"
                        id="btn-size-medium"
                        data-is-selected="N"
                        onclick="onBtnChonSizeMClick()"
                      >
                        Chọn
                      </button>
                    </div>
                  </div>
                </div>
                <div class="col-sm-4">
                  <div class="card">
                    <div
                      class="card-header bg-main-brand text-white text-center"
                    >
                      <h3>L ( Large size )</h3>
                    </div>
                    <div class="card-body text-center">
                      <ul class="list-group list-group-flush">
                        <li class="list-group-item">
                          Đường kính <b> 30 cm</b>
                        </li>
                        <li class="list-group-item">Sườn nướng <b>8</b></li>
                        <li class="list-group-item">Salad <b> 500 gr</b></li>
                        <li class="list-group-item">Nước ngọt <b>4</b></li>
                        <li class="list-group-item">
                          <h1>VND <b>250,000</b></h1>
                        </li>
                      </ul>
                    </div>
                    <div class="card-footer text-center">
                      <button
                        class="btn-green"
                        id="btn-size-large"
                        data-is-selected="N"
                        onclick="onBtnChonSizeLClick()"
                      >
                        Chọn
                      </button>
                    </div>
                  </div>
                </div> -->
              </div>
            </div>
          </div>

          <div id="type" class="row">
            <!-- Title Pizza Type -->
            <div class="col-sm-12 text-center p-4 mt-4">
              <h2><b class="p-2 border-bottom">Chọn loại pizza</b></h2>
            </div>

            <!-- Content Pizza Type -->
            <div class="col-sm-12">
              <div class="row" id="div-row-type">
                <!-- <div class="col-sm-4">
                  <div class="card w-100" style="width: 18rem;">
                    <img
                      src="images/pizza_type_hawai.jpg"
                      class="card-img-top"
                    />
                    <div class="card-body">
                      <h3>Pizza Hawai</h3>
                      <p>Món ăn thanh đạm</p>
                      <p>
                        Hãy thưởng thức món ăn với phong cách Alo Ha đến từ
                        Hawai.
                      </p>
                      <p>
                        <button
                          class="btn-green"
                          id="btn-type-hawai"
                          data-is-selected="N"
                          onclick="onBtnChonHawai()"
                        >
                          Chọn
                        </button>
                      </p>
                    </div>
                  </div>
                </div>
                <div class="col-sm-4">
                  <div class="card w-100" style="width: 18rem;">
                    <img
                      src="images/pizza_type_hai_san.jpg"
                      class="card-img-top"
                    />
                    <div class="card-body">
                      <h3>Pizza Hải sản</h3>
                      <p>Món ăn đến từ biển</p>
                      <p>
                        Bạn đã thử pizza được chế biến từ nguyên liệu hải sản
                        chưa ?
                      </p>
                      <p>
                        <button
                          class="btn-green"
                          id="btn-type-hai-san"
                          data-is-selected="N"
                          onclick="onBtnChonHaisan()"
                        >
                          Chọn
                        </button>
                      </p>
                    </div>
                  </div>
                </div>
                <div class="col-sm-4">
                  <div class="card w-100" style="width: 18rem;">
                    <img
                      src="images/pizza_type_thit_nuong.jpg"
                      class="card-img-top"
                    />
                    <div class="card-body">
                      <h3>Pizza Bacon</h3>
                      <p>Món ăn đăc biệt</p>
                      <p>
                        Được chế biến từ thịt bacon. Mang đến hương vị mới lạ.
                      </p>
                      <p>
                        <button
                          class="btn-green"
                          id="btn-type-bacon"
                          data-is-selected="N"
                          onclick="onBtnChonBacon()"
                        >
                          Chọn
                        </button>
                      </p>
                    </div>
                  </div>
                </div> -->
              </div>
            </div>
          </div>

          <div style="margin-top: 3rem;">
            <label
              for="select-drink"
              style="
                font-weight: 600;
                font-size: 2rem;
                text-align: center;
                width: 100%;
              "
              >Menu Đồ Uống</label
            >
            <br />
            <select id="select-drink" style="width: 100%; padding: 0.5rem;">
              <option value="0">-- Chọn đồ uống --</option>
            </select>
          </div>

          <div id="contact" class="row">
            <!-- Title Form Contact Us -->
            <div class="col-sm-12 text-center p-4 mt-4">
              <h2><b class="p-2 border-bottom">Thông tin đơn hàng</b></h2>
            </div>

            <!-- Content Form Contact Us -->
            <div class="col-sm-12 p-2 jumbotron">
              <div class="row">
                <div class="col-sm-12">
                  <div class="form-group">
                    <label for="input-name">Họ và tên</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-name"
                      placeholder="Họ và tên"
                    />
                  </div>
                  <div class="form-group">
                    <label for="email">Email</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-email"
                      placeholder="Email"
                    />
                  </div>
                  <div class="form-group">
                    <label for="input-phone">Điện thoại</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-phone"
                      placeholder="Điện thoại"
                    />
                  </div>
                  <div class="form-group">
                    <label for="input-address">Địa chỉ</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-address"
                      placeholder="Địa chỉ"
                    />
                  </div>
                  <div class="form-group">
                    <label for="message">Lời nhắn</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-message"
                      placeholder="Lời nhắn"
                    />
                  </div>

                  <div class="form-group">
                    <label for="message">Mã giảm giá (Voucher ID)</label>
                    <input
                      type="text"
                      class="form-control"
                      id="input-voucherID"
                      placeholder="Mã voucher"
                    />
                  </div>

                  <button
                    type="button"
                    class="btn-green"
                    onclick="onBtnKiemTraDonClick()"
                  >
                    Kiểm tra đơn
                  </button>
                </div>
              </div>
            </div>
            <!-- vùng hiển thị thông tin đơn hàng(order) -->
            <div
              id="div-container-order"
              class="container bg-info p-2 jumbotron"
              style="display: none;"
            >
              <div id="div-order-infor" class="text-white p-3">
                thông tin đơn hàng vào đây
              </div>
              <div class="p-2">
                <button
                  type="button"
                  class="btn-yellow"
                  onclick="onBtnGuiDonClick()"
                >
                  Gửi đơn
                </button>
              </div>
            </div>

            <div
              class="container bg-warning p-3 mt-2 jumbotron"
              style="display: none;"
              id="div-container-Cam-on"
            >
              <div>
                Cảm ơn bạn đã đặt hàng tại Pizza 365. Mã đơn hàng của bạn là:
              </div>
              <div style="display: flex; align-items: center;">
                <div>Mã đơn hàng:</div>
                <div
                  id="div-ma-don-hang"
                  style="
                    width: 50%;
                    border: 1px black solid;
                    margin: 1rem;
                    padding-bottom: 3px;
                    padding-left: 1rem;
                  "
                ></div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Footer -->
    <div class="container-fluid bg-light p-3">
      <div class="row text-center">
        <div class="col-sm-12">
          <h4 class="m-2">Footer</h4>
          <a href="#" class="btn bg-main-brand text-white m-3"
            ><i class="fa fa-arrow-up mr-2"></i>To the top</a
          >
          <div class="m-2">
            <i class="fa fa-facebook-official text-main"></i>
            <i class="fa fa-instagram text-main"></i>
            <i class="fa fa-snapchat text-main"></i>
            <i class="fa fa-pinterest-p text-main"></i>
            <i class="fa fa-twitter text-main"></i>
            <i class="fa fa-linkedin text-main"></i>
          </div>
        </div>
      </div>
    </div>
  </body>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Mảng danh sách các mã giảm giá
    var gDiscountVouchers = [
      { voucherID: "10345", percentDiscount: 20 }, // mã giảm giá là 10345, phần trăm giảm giá 20%
      { voucherID: "11346", percentDiscount: 10 },
      { voucherID: "20445", percentDiscount: 5 },
      { voucherID: "21457", percentDiscount: 30 },
      { voucherID: "32154", percentDiscount: 20 },
      { voucherID: "30546", percentDiscount: 25 },
      { voucherID: "41351", percentDiscount: 15 },
      { voucherID: "53360", percentDiscount: 5 },
      { voucherID: "65343", percentDiscount: 30 },
      { voucherID: "78328", percentDiscount: 40 },
    ];

    const gSIZE_S = "Pizza Size S";
    const gSIZE_M = "Pizza Size M";
    const gSIZE_L = "Pizza Size L";

    const gLOAI_HAWAI = "Pizza Hawai";
    const gLOAI_HAI_SAN = "Pizza Hải sản";
    const gLOAI_BACON = "Pizza Bacon";

    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201;

    var gOrderObj = {
      kichCo: "",
      duongKinh: "",
      suon: "",
      salad: "",
      loaiPizza: "",
      idVoucher: "",
      idLoaiNuocUong: "",
      soLuongNuoc: "",
      hoTen: "",
      thanhTien: "",
      email: "",
      soDienThoai: "",
      diaChi: "",
      loiNhan: "",
    };

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm thực thi khi tải trang
    function onPageLoading() {
      // var vXhttp = new XMLHttpRequest();
      // goiApiDrink(vXhttp);

      // vXhttp.onreadystatechange = function () {
      //   if (
      //     this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
      //     this.status == gREQUEST_STATUS_OK
      //   ) {
      //     console.log(vXhttp.responseText); // ghi response text ra console.log
      //     var bDrinkList = JSON.parse(vXhttp.responseText);
      //     hienThiListDrink(bDrinkList);
      //   }
      // };

      $.ajax({
        url: "https://647406377de100807b1a4df4.mockapi.io/combos",
        type: "GET",
        dataType: "json", // added data type
        success: function (res) {
          console.log(res);
          loadComboOnWeb(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        },
      });

      $.ajax({
        url: "https://647406377de100807b1a4df4.mockapi.io/types",
        type: "GET",
        dataType: "json", // added data type
        success: function (res) {
          console.log(res);
          loadTypeOnWeb(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        },
      });

      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
        type: "GET",
        dataType: "json", // added data type
        success: function (res) {
          console.log(res);
          hienThiListDrink(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        },
      });
    }

    //Ham xu ly su kien khi nut Chon size S click
    function onBtnChonSizeSClick() {
      markSelectedSize(gSIZE_S);
    }

    //Ham xu ly su kien khi nut Chon size M click
    function onBtnChonSizeMClick() {
      markSelectedSize(gSIZE_M);
    }

    //Ham xu ly su kien khi nut Chon size L click
    function onBtnChonSizeLClick() {
      markSelectedSize(gSIZE_L);
    }

    //Ham xu ly su kien khi nut Chon loai pizza Hawai click
    function onBtnChonHawai() {
      markSelectedLoai(gLOAI_HAWAI);
    }

    //Ham xu ly su kien khi nut Chon loai pizza Hai san click
    function onBtnChonHaisan() {
      markSelectedLoai(gLOAI_HAI_SAN);
    }

    //Ham xu ly su kien khi nut Chon loai pizza Bacon click
    function onBtnChonBacon() {
      markSelectedLoai(gLOAI_BACON);
    }

    //Ham xu ly su kien khi nut Kiem tra don click
    function onBtnKiemTraDonClick() {
      // khai báo đối tượng dữ liệu sẽ xử lý
      var vDataObj = {
        sizePizza: null,
        loaiPizza: "",
        doUong: "",
        hoVaTen: "",
        email: "",
        dienThoai: "",
        diaChi: "",
        loiNhan: "",
        voucherID: "",
        showOrderInfor: function () {
          console.log(vDataObj);
        },
      };
      // 1. đọc dữ liệu ở trên trang web
      thuThapDuLieuDonHang(vDataObj);
      // 2. Kiểm tra điều kiện đầu vào
      var vDuLieuHopLe = kiemTraDuLieuDonHang(vDataObj);
      if (vDuLieuHopLe) {
        hienThiThongTinDonhang(vDataObj);
      }
    }

    //Ham xu ly su kien khi nut Gui don click
    function onBtnGuiDonClick() {
      console.log(gOrderObj);

      //B3: Gọi api create order
      var vXmlHttpCreateOrder = new XMLHttpRequest();
      goiApiCreateOrder(vXmlHttpCreateOrder, gOrderObj);

      vXmlHttpCreateOrder.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_CREATE_SUCCESS
        ) {
          // status 201 tao thanh cong
          var vCreatedOrder = vXmlHttpCreateOrder.responseText;
          console.log(vCreatedOrder);
          var vNewOrderObj = JSON.parse(vCreatedOrder);
          //B4: hiển thị thông tin
          hienThiThongTinCreateOrder(vNewOrderObj);
        }
      };
    }

    $(document).on(
      "click",
      "#btn-size-S, #btn-size-M, #btn-size-L",
      function () {
        var vSize = $(this).data("size");
        markSelectedSize(vSize);
      }
    );

    $(document).on("click", "#btn-type-seafood", function () {
      onBtnChonHaisan();
    });

    $(document).on("click", "#btn-type-hawai", function () {
      onBtnChonHawai();
    });

    $(document).on("click", "#btn-type-bacon", function () {
      onBtnChonBacon();
    });

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function trả lại một đối tượng size theo tham số truyền vào
    function getSize(
      paramPizzaSize,
      paramDuongKinh,
      paramSuonNuong,
      paramSalad,
      paramNuocNgot,
      paramGia
    ) {
      var vSelectedSize = {
        pizzaSize: paramPizzaSize,
        duongKinh: paramDuongKinh,
        suonNuong: paramSuonNuong,
        salad: paramSalad,
        nuocNgot: paramNuocNgot,
        gia: paramGia,
        // method display size info
        showSizeInfo: function () {
          console.log("%cThông tin size pizza được chọn ...", "color: orange");
          console.log(this.pizzaSize);
          console.log("Đường kính " + this.duongKinh);
          console.log("Sườn nướng " + this.suonNuong);
          console.log("Salad " + this.salad);
          console.log("Nước ngọt " + this.nuocNgot);
          console.log("Giá:" + this.gia);
        },
      };

      // trả lại đối tượng, có đủ dữ liệu (properties) và các methods (phương thức)
      return vSelectedSize;
    }
    /* Đánh dấu size vừa được chọn gồm 2 việc:
    1. đổi màu button (Chọn) để phân biệt size được chọn
    2. đổi giá trị thuộc tính data-is-selected tương ứng, nút đc chọn là Y, 2 nút còn lại là N
    */
    function markSelectedSize(paramSize) {
      var vSizeSelected = null;
      // Truy vấn 3 nút tương ứng với 3 size
      var vBtnChonSizeS = $("#btn-size-S");
      var vBtnChonSizeM = $("#btn-size-M");
      var vBtnChonSizeL = $("#btn-size-L");

      // nếu chọn Size S thì thay màu vàng nút Chọn và đổi thuộc tính data-is-selected = Y
      // 2 nút còn lại đổi sang màu xanh và data-is-selected = N
      if (paramSize == "S") {
        vBtnChonSizeS.attr("class", "btn-yellow");
        vBtnChonSizeS.attr("data-is-selected", "Y");

        vBtnChonSizeM.attr("class", "btn-green");
        vBtnChonSizeM.attr("data-is-selected", "N");

        vBtnChonSizeL.attr("class", "btn-green");
        vBtnChonSizeL.attr("data-is-selected", "N");

        vSizeSelected = getSize(
          gSIZE_S,
          "20 cm",
          "2",
          "200 gr",
          "2",
          "150,000 VND"
        );
      }
      // làm tương tự cho 2 nút còn lại
      else if (paramSize == "M") {
        vBtnChonSizeS.attr("class", "btn-green");
        vBtnChonSizeS.attr("data-is-selected", "N");

        vBtnChonSizeM.attr("class", "btn-yellow");
        vBtnChonSizeM.attr("data-is-selected", "Y");

        vBtnChonSizeL.attr("class", "btn-green");
        vBtnChonSizeL.attr("data-is-selected", "N");

        // lấy thông tin size và hiển thị ra console
        vSizeSelected = getSize(
          gSIZE_M,
          "25 cm",
          "4",
          "300 gr",
          "3",
          "200,000 VND"
        );
      } else if (paramSize == "L") {
        vBtnChonSizeS.attr("class", "btn-green");
        vBtnChonSizeS.attr("data-is-selected", "N");

        vBtnChonSizeM.attr("class", "btn-green");
        vBtnChonSizeM.attr("data-is-selected", "N");

        vBtnChonSizeL.attr("class", "btn-yellow");
        vBtnChonSizeL.attr("data-is-selected", "Y");

        vSizeSelected = getSize(
          gSIZE_L,
          "30 cm",
          "8",
          "500 gr",
          "4",
          "250,000 VND"
        );
      }

      vSizeSelected.showSizeInfo();
    }

    /* Đánh dấu loại pizza vừa được chọn gồm 2 việc:
    1. đổi màu button (Chọn) để phân biệt loại pizza được chọn
    2. đổi giá trị thuộc tính data-is-selected tương ứng, nút đc chọn là Y, 2 nút còn lại là N
    */
    function markSelectedLoai(paramLoai) {
      var vLoaiSelected = "";
      // Truy vấn 3 nút tương ứng với 3 loại
      var vBtnChonLoaiHawai = document.getElementById("btn-type-hawai");
      var vBtnChonLoaiHaiSan = document.getElementById("btn-type-seafood");
      var vBtnChonLoaiBacon = document.getElementById("btn-type-bacon");

      // nếu chọn loại Hawai thì thay màu vàng nút Chọn và đổi thuộc tính data-is-selected = Y
      // 2 nút còn lại đổi sang màu xanh và data-is-selected = N
      if (paramLoai == gLOAI_HAWAI) {
        vBtnChonLoaiHawai.className = "btn-yellow";
        vBtnChonLoaiHawai.setAttribute("data-is-selected", "Y");

        vBtnChonLoaiHaiSan.className = "btn-green";
        vBtnChonLoaiHaiSan.setAttribute("data-is-selected", "N");

        vBtnChonLoaiBacon.className = "btn-green";
        vBtnChonLoaiBacon.setAttribute("data-is-selected", "N");

        vLoaiSelected = gLOAI_HAWAI;
      }
      // làm tương tự cho 2 nút còn lại
      else if (paramLoai == gLOAI_HAI_SAN) {
        vBtnChonLoaiHawai.className = "btn-green";
        vBtnChonLoaiHawai.setAttribute("data-is-selected", "N");

        vBtnChonLoaiHaiSan.className = "btn-yellow";
        vBtnChonLoaiHaiSan.setAttribute("data-is-selected", "Y");

        vBtnChonLoaiBacon.className = "btn-green";
        vBtnChonLoaiBacon.setAttribute("data-is-selected", "N");

        vLoaiSelected = gLOAI_HAI_SAN;
      } else if (paramLoai == gLOAI_BACON) {
        vBtnChonLoaiHawai.className = "btn-green";
        vBtnChonLoaiHawai.setAttribute("data-is-selected", "N");

        vBtnChonLoaiHaiSan.className = "btn-green";
        vBtnChonLoaiHaiSan.setAttribute("data-is-selected", "N");

        vBtnChonLoaiBacon.className = "btn-yellow";
        vBtnChonLoaiBacon.setAttribute("data-is-selected", "Y");

        vLoaiSelected = gLOAI_BACON;
      }

      console.log("Loại pizza được chọn: " + vLoaiSelected);
    }

    //======================SubTask4==============================

    // function trả lại một đối tượng menu (size combo) theo tham số truyền vào
    function getMenu(
      paramMenuName,
      paramDuongKinhCM,
      paramSuonNuong,
      paramSaladGr,
      paramDrink,
      paramPriceVND
    ) {
      var vSelectedSize = {
        menuName: paramMenuName,
        duongKinhCM: paramDuongKinhCM,
        suonNuong: paramSuonNuong,
        saladGr: paramSaladGr,
        drink: paramDrink,
        priceVND: paramPriceVND,
        // method display size info
        displayInConsoleLog: function () {
          console.log(
            "%Combo pizza được chọn: " + this.menuName,
            "color: orange"
          );
        },
      };

      // trả lại đối tượng, có đủ dữ liệu (properties) và các methods (phương thức)
      return vSelectedSize;
    }

    // function trả lại một đối tượng order (đơn hàng) theo tham số truyền vào
    function getOrder(
      paramMenuDuocChon,
      paramLoaiPizza,
      paramHoVaTen,
      paramEmail,
      paramDienThoai,
      paramDiaChi,
      paramLoiNhan,
      paramVoucher,
      paramPhanTramGiamGia
    ) {
      var vOrderObj = {
        menuDuocChon: paramMenuDuocChon,
        loaiPizza: paramLoaiPizza,
        hoVaTen: paramHoVaTen,
        email: paramEmail,
        dienThoai: paramDienThoai,
        diaChi: paramDiaChi,
        loiNhan: paramLoiNhan,
        voucher: paramVoucher,
        phanTramGiamGia: paramPhanTramGiamGia,
        priceDaGiamVND: function () {
          return this.menuDuocChon.priceVND * (1 - this.phanTramGiamGia / 100);
        },
      };

      // trả lại đối tượng, có đủ dữ liệu (properties) và các methods (phương thức)
      return vOrderObj;
    }

    // B1: hàm thu thập dữ liệu đơn hàng
    function thuThapDuLieuDonHang(paramDataObj) {
      var vDrinkSelect = document.getElementById("select-drink");
      var vHoTenInput = document.getElementById("input-name");
      var vEmailInput = document.getElementById("input-email");
      var vDienThoaiInput = document.getElementById("input-phone");
      var vDiaChiInput = document.getElementById("input-address");
      var vLoiNhanInput = document.getElementById("input-message");
      var vVoucherIDInput = document.getElementById("input-voucherID");

      paramDataObj.doUong = vDrinkSelect.value;
      paramDataObj.hoVaTen = vHoTenInput.value.trim();
      paramDataObj.email = vEmailInput.value.trim();
      paramDataObj.dienThoai = vDienThoaiInput.value.trim();
      paramDataObj.diaChi = vDiaChiInput.value.trim();
      paramDataObj.loiNhan = vLoiNhanInput.value.trim();
      paramDataObj.voucherID = vVoucherIDInput.value.trim();

      //lấy thông tin size pizza đã chọn
      var vBtnChonSizeS = document.getElementById("btn-size-small");
      var vBtnChonSizeM = document.getElementById("btn-size-medium");
      var vBtnChonSizeL = document.getElementById("btn-size-large");

      var vSizeSChon = vBtnChonSizeS.getAttribute("data-is-selected");
      var vSizeMChon = vBtnChonSizeM.getAttribute("data-is-selected");
      var vSizeLChon = vBtnChonSizeL.getAttribute("data-is-selected");

      if (vSizeSChon === "Y") {
        paramDataObj.sizePizza = getMenu(gSIZE_S, 20, 2, 200, 2, 150000);
      } else if (vSizeMChon === "Y") {
        paramDataObj.sizePizza = getMenu(gSIZE_M, 25, 4, 300, 3, 200000);
      } else if (vSizeLChon === "Y") {
        paramDataObj.sizePizza = getMenu(gSIZE_L, 30, 8, 500, 4, 250000);
      }

      //lấy thông tin loại pizza đã chọn
      var vBtnChonLoaiHawai = document.getElementById("btn-type-hawai");
      var vBtnChonLoaiHaiSan = document.getElementById("btn-type-hai-san");
      var vBtnChonLoaiBacon = document.getElementById("btn-type-bacon");

      var vLoaiHawaiChon = vBtnChonLoaiHawai.getAttribute("data-is-selected");
      var vLoaiHaiSanChon = vBtnChonLoaiHaiSan.getAttribute("data-is-selected");
      var vLoaiBaconChon = vBtnChonLoaiBacon.getAttribute("data-is-selected");

      if (vLoaiHawaiChon === "Y") {
        paramDataObj.loaiPizza = gLOAI_HAWAI;
      } else if (vLoaiHaiSanChon === "Y") {
        paramDataObj.loaiPizza = gLOAI_HAI_SAN;
      } else if (vLoaiBaconChon === "Y") {
        paramDataObj.loaiPizza = gLOAI_BACON;
      }

      console.log(paramDataObj);
    }

    // B2: hàm kiểm tra dữ liệu đơn hàng
    function kiemTraDuLieuDonHang(vDataObj) {
      if (vDataObj.hoVaTen == "") {
        alert("bạn cần nhập họ và tên!");
        return false;
      }

      if (vDataObj.email == "") {
        alert("bạn cần nhập email!");
        return false;
      }
      if (validateEmail(vDataObj.email) == false) {
        alert("Email nhập vào không đúng định dạng!");
        return false;
      }

      if (vDataObj.dienThoai == "") {
        alert("bạn cần nhập số điện thoại!");
        return false;
      }
      if (validatePhone(vDataObj.dienThoai) == false) {
        alert("Số điện thoại nhập vào không đúng định dạng!");
        return false;
      }

      if (vDataObj.diaChi == "") {
        alert("bạn cần nhập địa chỉ!");
        return false;
      }

      if (vDataObj.sizePizza == null) {
        alert("bạn cần chọn size (combo) pizza!");
        return false;
      }

      if (vDataObj.loaiPizza == "") {
        alert("bạn cần chọn loại pizza!");
        return false;
      }

      if (vDataObj.doUong == "0") {
        alert("bạn cần chọn nước uống!");
        return false;
      }

      return true;
    }

    //hàm kiểm tra số điện thoại
    function validatePhone(paramPhone) {
      // Số điện thoại phải nhập là số, có dấu + hoặc số 0 ở đầu; độ dài từ 10 đến 12 ký tự

      if (isNaN(paramPhone)) {
        return false;
      }

      if (paramPhone.charAt(0) != "0" && paramPhone.charAt(0) != "+") {
        return false;
      }

      if (paramPhone.length < 10 || paramPhone.length > 12) {
        return false;
      }

      return true;
    }

    // hàm kiểm tra email đúng định dạng ko?
    function validateEmail(paramEmail) {
      var vValidRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      if (paramEmail.match(vValidRegex)) {
        return true;
      } else {
        return false;
      }
    }

    // B3: hàm hiển thị thông tin đơn hàng
    function hienThiThongTinDonhang(paramDataObj) {
      var vDivCamOnContainer = document.getElementById("div-container-Cam-on");
      vDivCamOnContainer.style.display = "none";

      //tìm voucher, không tìm được thì alert cho khách mã giảm giá không tồn tại
      var vVoucherP = 0;
      if (paramDataObj.voucherID != "") {
        vVoucherP = layPhanTramGiamGia(paramDataObj.voucherID);
      }

      var vOrderObj = {
        menuDuocChon: paramDataObj.sizePizza,
        loaiPizza: paramDataObj.loaiPizza,
        loaiNuocUong: paramDataObj.doUong,
        hoVaTen: paramDataObj.hoVaTen,
        email: paramDataObj.email,
        dienThoai: paramDataObj.dienThoai,
        diaChi: paramDataObj.diaChi,
        loiNhan: paramDataObj.loiNhan,
        voucher: paramDataObj.voucherID,
        phanTramGiamGia: vVoucherP,
        priceDaGiamVND: function () {
          return this.menuDuocChon.priceVND * (1 - this.phanTramGiamGia / 100);
        },
      };

      //hiển thị vùng thông tin đơn hàng
      var vDivContainer = document.getElementById("div-container-order");
      var vDivOrderInfo = document.getElementById("div-order-infor");

      vDivContainer.style.display = "block";

      vDivOrderInfo.innerHTML = `
        Họ và tên: ${vOrderObj.hoVaTen}<br>
        Email: ${vOrderObj.email}<br>
        Số điện thoại: ${vOrderObj.dienThoai}<br>
        Địa chỉ: ${vOrderObj.diaChi}<br>
        Lời nhắn: ${vOrderObj.loiNhan}<br>
        -------------------------------------<br>
        Kích cỡ: ${vOrderObj.menuDuocChon.menuName}<br>
        Đường kính: ${vOrderObj.menuDuocChon.duongKinhCM}<br>
        Sườn nướng: ${vOrderObj.menuDuocChon.suonNuong}<br>
        Salad: ${vOrderObj.menuDuocChon.saladGr}<br>
        Nước ngọt: ${vOrderObj.menuDuocChon.drink}<br>
        Loại nước uống: ${vOrderObj.loaiNuocUong}<br>
        --------------------------------------<br>
        Loại Pizza: ${vOrderObj.loaiPizza}<br>
        Mã Voucher: ${vOrderObj.voucher}<br>
        Giá vnd: ${vOrderObj.menuDuocChon.priceVND}<br>
        Discount %: ${vOrderObj.phanTramGiamGia}<br>
        Phải thanh toán vnd: ${vOrderObj.priceDaGiamVND()}
      `;

      gOrderObj.kichCo = vOrderObj.menuDuocChon.menuName;
      gOrderObj.duongKinh = vOrderObj.menuDuocChon.duongKinhCM;
      gOrderObj.suon = vOrderObj.menuDuocChon.suonNuong;
      gOrderObj.salad = vOrderObj.menuDuocChon.saladGr;
      gOrderObj.loaiPizza = vOrderObj.loaiPizza;
      gOrderObj.idVoucher = vOrderObj.voucher;
      gOrderObj.idLoaiNuocUong = vOrderObj.loaiNuocUong;
      gOrderObj.soLuongNuoc = vOrderObj.menuDuocChon.drink;
      gOrderObj.hoTen = vOrderObj.hoVaTen;
      gOrderObj.thanhTien = vOrderObj.priceDaGiamVND();
      gOrderObj.email = vOrderObj.email;
      gOrderObj.soDienThoai = vOrderObj.dienThoai;
      gOrderObj.diaChi = vOrderObj.diaChi;
      gOrderObj.loiNhan = vOrderObj.loiNhan;
    }

    //hàm tìm kiếm voucher theo voucherID
    function getVoucherByVoucherID(paramVoucherID) {
      var vFound = false;
      var vIndex = 0;
      var vVoucherObj = null;

      while (vFound == false && vIndex < gDiscountVouchers.length) {
        if (gDiscountVouchers[vIndex].voucherID == paramVoucherID) {
          vFound = true;
          vVoucherObj = gDiscountVouchers[vIndex];
        } else {
          vIndex++;
        }
      }

      return vVoucherObj;
    }

    //hàm gọi api để load danh sách đồ uống
    function goiApiDrink(paramXhttp) {
      paramXhttp.open(
        "GET",
        "http://203.171.20.210:8080/devcamp-pizza365/drinks",
        true
      );
      paramXhttp.send();
    }

    //hàm hiển thị ds đồ uống
    function hienThiListDrink(paramDrinkList) {
      var vDrinkListSelect = document.getElementById("select-drink");
      for (
        var bViTriHienTai = 0;
        bViTriHienTai < paramDrinkList.length;
        bViTriHienTai++
      ) {
        var bDrinkObj = paramDrinkList[bViTriHienTai];

        var bDrinkElement = document.createElement("option");
        bDrinkElement.text = bDrinkObj.tenNuocUong;
        bDrinkElement.value = bDrinkObj.maNuocUong;

        vDrinkListSelect.add(bDrinkElement);
      }
    }

    //hàm lấy phần trăm giảm giá từ voucherId
    function layPhanTramGiamGia(paramVoucherID) {
      var vVoucherP = 0;
      var vXmlHttp = new XMLHttpRequest();

      goiApiVoucher(vXmlHttp, paramVoucherID);

      if (vXmlHttp.status == gREQUEST_STATUS_OK) {
        // restFullAPI successful
        // nhận lại response dạng JSON ở vXmlHttp.responseText và chuyển thành object
        console.log(vXmlHttp.responseText);
        var bVoucherObj = JSON.parse(vXmlHttp.responseText);
        vVoucherP = parseInt(bVoucherObj.phanTramGiamGia);
      } else {
        // không nhận lại được data do vấn đề gì đó: khả năng mã voucher ko dúng
        alert("Không tìm thấy voucher với id: " + paramVoucherID);
      }

      return vVoucherP;
    }

    //hàm gọi api để lấy phần trăm giảm giá từ voucherId
    function goiApiVoucher(paramXmlHttp, paramVoucherID) {
      const vBASE_URL =
        "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail/";

      paramXmlHttp.open("GET", vBASE_URL + paramVoucherID, false);
      paramXmlHttp.send();
    }

    //hàm gọi api create order
    function goiApiCreateOrder(paramXmlHttpCreateOrder, paramOrderObj) {
      const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

      paramXmlHttpCreateOrder.open("POST", vBASE_URL, true);
      paramXmlHttpCreateOrder.setRequestHeader(
        "Content-Type",
        "application/json;charset=UTF-8"
      );
      paramXmlHttpCreateOrder.send(JSON.stringify(paramOrderObj));
    }

    //hàm hiển thị thông tin order create
    function hienThiThongTinCreateOrder(paramNewOrderObj) {
      var vDivContainer = document.getElementById("div-container-order");
      var vDivCamOnContainer = document.getElementById("div-container-Cam-on");
      var vDivMaDonHang = document.getElementById("div-ma-don-hang");

      vDivContainer.style.display = "none";
      vDivCamOnContainer.style.display = "block";
      vDivMaDonHang.innerHTML = paramNewOrderObj.orderCode;
    }

    //hàm load dữ liệu combo lên trang web
    function loadComboOnWeb(paramRes) {
      for (var bI = 0; bI < paramRes.length; bI++) {
        var bComboObj = paramRes[bI];
        var bHtml = `
        <div class="col-sm-4">
                  <div class="card">
                    <div
                      class="card-header bg-main-brand text-white text-center"
                    >
                      <h3>${bComboObj.kichCo} ( Small size)</h3>
                    </div>
                    <div class="card-body text-center">
                      <ul class="list-group list-group-flush">
                        <li class="list-group-item">
                          Đường kính <b> ${bComboObj.duongKinh}</b>
                        </li>
                        <li class="list-group-item">Sườn nướng <b>${bComboObj.suonNuong}</b></li>
                        <li class="list-group-item">Salad <b>${bComboObj.salad}</b></li>
                        <li class="list-group-item">Nước ngọt <b>${bComboObj.nuocNgot}</b></li>
                        <li class="list-group-item">
                          <h1>VND <b>${bComboObj.thanhTien}</b></h1>
                        </li>
                      </ul>
                    </div>
                    <div class="card-footer text-center">
                      <button
                        class="btn-green combo-size"
                        id="btn-size-${bComboObj.kichCo}"
                        data-is-selected="N"
                        data-size="${bComboObj.kichCo}"
                      >
                        Chọn
                      </button>
                    </div>
                  </div>
                </div>
        `;
        $("#div-row-size-combo").append(bHtml);
      }
    }

    //hàm load dữ liệu pizza type lên trang web
    function loadTypeOnWeb(paramRes) {
      for (var bI = 0; bI < paramRes.length; bI++) {
        var bTypeObj = paramRes[bI];
        var bHtml = `
        <div class="col-sm-4">
                  <div class="card w-100" style="width: 18rem;">
                    <img
                      src="images/pizza_type_${bTypeObj.loaiPizza}.jpg"
                      class="card-img-top"
                    />
                    <div class="card-body">
                      <h3>${bTypeObj.name}</h3>
                      <p>${bTypeObj.note}</p>
                      <p>
                        ${bTypeObj.description}
                      </p>
                      <p>
                        <button
                          class="btn-green"
                          id="btn-type-${bTypeObj.loaiPizza}"
                          data-is-selected="N"
                        >
                          Chọn
                        </button>
                      </p>
                    </div>
                  </div>
                </div>
        `;
        $("#div-row-type").append(bHtml);
      }
    }
  </script>
</html>
